// -----------------------------------------------------------------------------
//
// Author(s):     Peter Schraut (www.console-dev.de)
// Last Modified: 2nd July 2005
//
// Purpose:       Demo shows how to use the Splash Functions.
//
// -----------------------------------------------------------------------------
#include <hel.h>


// -----------------------------------------------------------------------------
// External Data
// -----------------------------------------------------------------------------
extern const unsigned short splashhel_Palette[256];
extern const unsigned char splashhel_Bitmap[38400];
extern const unsigned short splashtext_Palette[256];
extern const unsigned char splashtext_Bitmap[38400];

// -----------------------------------------------------------------------------
// Program Entry Point
// -----------------------------------------------------------------------------
int main(void)
{
    ham_Init();
    
    // hel_Splash only works in Mode 3, 4 and 5
    ham_SetBgMode(4);
    
    for(;;)
    {
      // Show the "SomeText" SplashScreen!
      hel_Splash((void*)splashtext_Bitmap,        // pBitmap
                 (void*)splashtext_Palette,       // pPalette
                 SPLASH_TYPE_BLACK,               // SplashTypeIn
                 SPLASH_TYPE_BLACK,               // SplashTypeOut
                 6,                               // FadeInSpeed
                 6,                               // FadeOutSpeed
                 40,                              // WaitFrames
                 16);                             // AfterWaitFrames

      // Show the HEL SplashScreen.
      hel_Splash((void*)splashhel_Bitmap,         // pBitmap
                 (void*)splashhel_Palette,        // pPalette
                 SPLASH_TYPE_BLACK,               // SplashTypeIn
                 SPLASH_TYPE_WHITE,               // SplashTypeOut
                 6,                               // FadeInSpeed
                 6,                               // FadeOutSpeed
                 40,                              // WaitFrames
                 0);                              // AfterWaitFrames


      // The last call to hel_Splash() cleared Video and Palette RAM.
      // We specify NULL for pBitmap and pPalette so it HEL knows not to
      // store a bitmap or palette.
      // Now we fade the screen from white to black.
      hel_Splash((void*)NULL,                     // pBitmap
                 (void*)NULL,                     // pPalette
                 SPLASH_TYPE_WHITE,               // SplashTypeIn
                 SPLASH_TYPE_BLACK,               // SplashTypeOut
                 16,                              // FadeInSpeed
                  6,                              // FadeOutSpeed
                  0,                              // WaitFrames
                 16);                             // AfterWaitFrames
    }
    
    return 0;
}


