// -----------------------------------------------------------------------------
//
// Author(s):     Peter Schraut (www.console-dev.de)
// Last Modified: 2nd July 2005
//
// Purpose:       Demo shows how to use the Custom Text System
//
// -----------------------------------------------------------------------------
#include <hel.h>


// -----------------------------------------------------------------------------
// Global Variables
// -----------------------------------------------------------------------------
TCustomTextInfo g_TextInfo =
{
    // Backgroundnumber
    0,

    // That's the order of chars how they
    // are located on the source graphic!
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmn"\
    "opqrstuvwxyz0123456789?,.-;: #^+*@"\
    "!\"%\%&/()=?|\\<>[]{}"
};

u8 g_NewFrame=TRUE;


// -----------------------------------------------------------------------------
// External Data
// -----------------------------------------------------------------------------
extern const unsigned char charset_Map[120];
extern const unsigned short charset_Palette[256];
extern const unsigned char charset_Tiles[7680];


// -----------------------------------------------------------------------------
// Program Entry Point
// -----------------------------------------------------------------------------
int main(void)
{
    ham_Init();
    ham_SetBgMode(0);

    // Init Textdraw System
    hel_CustomTextInit(&g_TextInfo,                 // Pointer to TCustomTextInfo
                       (void*)charset_Tiles,        // Pointer to the tile source data
                       SIZEOF_16BIT(charset_Tiles), // Size of the tiles to be copied into Tile RAM, in number of 16bit chunks
                       1,                           // Color mode of the tile set: 0 = 16colors/16 palettes 1 = 256 colors / 1 palette
                       0,                           // Palettenumber
                       MAP_SIZE_32X32,              // Size of the map (0-3). This depends on the map_rot parameter!
                       0);                          // 0 = normal map, 1 = rotation map

    // Load Background Palette
    hel_PalBgLoad256((void*)charset_Palette);
    
    // Turn on the background
    ham_InitBg(g_TextInfo.BgNo, BG_ACTIVE_ON, BG_PRIO_1, BG_MOSAIC_OFF);

    // Print moooore text :)
    hel_CustomTextPrint(&g_TextInfo, 4, 6, "Hello World,");
    hel_CustomTextPrint(&g_TextInfo, 4, 8, "this is the TextSystem");
    hel_CustomTextPrint(&g_TextInfo, 4, 9, "from HEL Library :-)");

    for(;;);

    return 0;
}


